/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.tables.records.UserAccountNumbersRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row4;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class UserAccountNumbers extends TableImpl<UserAccountNumbersRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.user_account_numbers</code>
     */
    public static final UserAccountNumbers USER_ACCOUNT_NUMBERS = new UserAccountNumbers();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<UserAccountNumbersRecord> getRecordType() {
        return UserAccountNumbersRecord.class;
    }

    /**
     * The column <code>accounting.user_account_numbers.user_id</code>.
     */
    public final TableField<UserAccountNumbersRecord, UUID> USER_ID = createField(DSL.name("user_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.user_account_numbers.account_number</code>.
     */
    public final TableField<UserAccountNumbersRecord, String> ACCOUNT_NUMBER = createField(DSL.name("account_number"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>accounting.user_account_numbers.validated</code>.
     */
    public final TableField<UserAccountNumbersRecord, Boolean> VALIDATED = createField(DSL.name("validated"), SQLDataType.BOOLEAN.nullable(false).defaultValue(DSL.field("false", SQLDataType.BOOLEAN)), this, "");

    /**
     * The column <code>accounting.user_account_numbers.encoding_date</code>.
     */
    public final TableField<UserAccountNumbersRecord, LocalDateTime> ENCODING_DATE = createField(DSL.name("encoding_date"), SQLDataType.LOCALDATETIME(6).nullable(false).defaultValue(DSL.field("now()", SQLDataType.LOCALDATETIME)), this, "");

    private UserAccountNumbers(Name alias, Table<UserAccountNumbersRecord> aliased) {
        this(alias, aliased, null);
    }

    private UserAccountNumbers(Name alias, Table<UserAccountNumbersRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.user_account_numbers</code> table reference
     */
    public UserAccountNumbers(String alias) {
        this(DSL.name(alias), USER_ACCOUNT_NUMBERS);
    }

    /**
     * Create an aliased <code>accounting.user_account_numbers</code> table reference
     */
    public UserAccountNumbers(Name alias) {
        this(alias, USER_ACCOUNT_NUMBERS);
    }

    /**
     * Create a <code>accounting.user_account_numbers</code> table reference
     */
    public UserAccountNumbers() {
        this(DSL.name("user_account_numbers"), null);
    }

    public <O extends Record> UserAccountNumbers(Table<O> child, ForeignKey<O, UserAccountNumbersRecord> key) {
        super(child, key, USER_ACCOUNT_NUMBERS);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public UniqueKey<UserAccountNumbersRecord> getPrimaryKey() {
        return Keys.USER_ACCOUNT_NUMBERS_PKEY;
    }

    @Override
    public List<UniqueKey<UserAccountNumbersRecord>> getKeys() {
        return Arrays.<UniqueKey<UserAccountNumbersRecord>>asList(Keys.USER_ACCOUNT_NUMBERS_PKEY, Keys.USER_ACCOUNT_NUMBERS_ACCOUNT_NUMBER_KEY);
    }

    @Override
    public List<ForeignKey<UserAccountNumbersRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<UserAccountNumbersRecord, ?>>asList(Keys.USER_ACCOUNT_NUMBERS__USER_ACCOUNT_NUMBERS_USER_ID_FKEY);
    }

    private transient Users _users;

    public Users users() {
        if (_users == null)
            _users = new Users(this, Keys.USER_ACCOUNT_NUMBERS__USER_ACCOUNT_NUMBERS_USER_ID_FKEY);

        return _users;
    }

    @Override
    public UserAccountNumbers as(String alias) {
        return new UserAccountNumbers(DSL.name(alias), this);
    }

    @Override
    public UserAccountNumbers as(Name alias) {
        return new UserAccountNumbers(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public UserAccountNumbers rename(String name) {
        return new UserAccountNumbers(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public UserAccountNumbers rename(Name name) {
        return new UserAccountNumbers(name, null);
    }

    // -------------------------------------------------------------------------
    // Row4 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row4<UUID, String, Boolean, LocalDateTime> fieldsRow() {
        return (Row4) super.fieldsRow();
    }
}
